diff -uNrd ircd-hybrid-6.2/src/channel.c ircd-hyb6.2-FEFr5/src/channel.c
--- ircd-hybrid-6.2/src/channel.c	Fri Aug 10 09:59:14 2001
+++ ircd-hyb6.2-FEFr5/src/channel.c	Tue Aug 21 02:37:15 2001
@@ -36,6 +36,7 @@
 #include "numeric.h"
 #include "s_serv.h"       /* captab */
 #include "s_user.h"
+#include "s_conf.h"
 #include "send.h"
 #include "struct.h"
 #include "whowas.h"
@@ -630,9 +631,21 @@
   if (chptr->mode.mode & MODE_NOPRIVMSGS && !lp)
     return (MODE_NOPRIVMSGS);
 
+  if (!lp || !(lp->flags & (CHFL_CHANOP|CHFL_VOICE))
+      && MyClient(cptr) && (is_banned(cptr, chptr) == CHFL_BAN))
+        return (MODE_BAN);
+
   return 0;
 }
 
+int IsSLine(struct Client *sptr)
+{
+        if ((find_special_conf(sptr->name,CONF_SLINE)) ||
+            (sptr->user && (find_special_conf((char *)sptr->user->server,CONF_SLINE))))
+                return 1;
+	return 0;
+}
+
 int     user_channel_mode(struct Client *cptr, struct Channel *chptr)
 {
   Link  *lp;
@@ -665,16 +678,18 @@
     *mbuf++ = 'i';
   if (chptr->mode.mode & MODE_NOPRIVMSGS)
     *mbuf++ = 'n';
+  if (chptr->mode.mode & MODE_NOCOLOR)
+    *mbuf++ = 'c';
   if (chptr->mode.limit)
     {
       *mbuf++ = 'l';
-      if (IsMember(cptr, chptr) || IsServer(cptr))
+      if (IsMember(cptr, chptr) || IsServer(cptr) || IsSLine(cptr))
         ircsprintf(pbuf, "%d ", chptr->mode.limit);
     }
   if (*chptr->mode.key)
     {
       *mbuf++ = 'k';
-      if (IsMember(cptr, chptr) || IsServer(cptr))
+      if (IsMember(cptr, chptr) || IsServer(cptr) || IsSLine(cptr))
         (void)strcat(pbuf, chptr->mode.key);
     }
   *mbuf++ = '\0';
@@ -820,6 +835,11 @@
     sendto_one(cptr, ":%s MODE %s %s %s",
                me.name, chptr->chname, modebuf, parabuf);
 
+  if (chptr->topic_time != 0)
+    sendto_one(cptr, ":%s STOPIC %s %ld %s :%s",
+	       me.name, chptr->chname, chptr->topic_time,
+	       chptr->topic_nick, chptr->topic);
+
   if(!IsCapable(cptr,CAP_EX))
     return;
 
@@ -956,7 +976,7 @@
   int   keychange = 0, limitset = 0;
   int   whatt = MODE_ADD, the_mode = 0;
   int   done_s = NO, done_p = NO;
-  int   done_i = NO, done_m = NO, done_n = NO, done_t = NO;
+  int   done_i = NO, done_m = NO, done_n = NO, done_t = NO, done_c = NO;
   struct Client *who;
   Link  *lp;
   char  *curr = parv[0], c, *arg, plus = '+', *tmpc;
@@ -975,30 +995,38 @@
    * lets stick mode/params that only the newer servers will understand
    * into modebuf_new/parabuf_new 
    */
+  /*
+   * EVEN WORSE! Thanks to +c, we have nodebuf_fef <-- for CAP_FEF
+   * -JailBird
+   */
 
   char  modebuf_new[MODEBUFLEN];
   char  parabuf_new[MODEBUFLEN];
 
+  char	modebuf_fef[MODEBUFLEN];
+
   char  *mbufw = modebuf, *mbuf2w = modebuf2;
   char  *pbufw = parabuf, *pbuf2w = parabuf2;
 
   char  *mbufw_new = modebuf_new;
   char  *pbufw_new = parabuf_new;
 
+  char	*mbufw_fef = modebuf_fef;
+
   int   ischop;
   int   isok;
   int   isdeop;
   int   chan_op;
-  int   user_mode_chan;
+  int	user_mode_chan;
 
   user_mode_chan = user_channel_mode(sptr, chptr);
   chan_op = (user_mode_chan & CHFL_CHANOP);
 
   /* has ops or is a server */
-  ischop = IsServer(sptr) || chan_op;
+  ischop = IsServer(sptr) || chan_op || IsSLine(sptr);
 
   /* is client marked as deopped */
-  isdeop = !ischop && !IsServer(sptr) && (user_mode_chan & CHFL_DEOPPED);
+  isdeop = !ischop && !IsServer(sptr) && !IsSLine(sptr) && (user_mode_chan & CHFL_DEOPPED);
 
   /* is an op or server or remote user on a TS channel */
   isok = ischop || (!isdeop && IsServer(cptr) && chptr->channelts);
@@ -1104,7 +1132,7 @@
             break;
 
           /* no more of that mode bouncing crap */
-          if (!IsMember(who, chptr))
+          if (!IsMember(who, chptr) && !IsSLine(sptr))
             {
               if (MyClient(sptr))
                 sendto_one(sptr, form_str(ERR_USERNOTINCHANNEL), me.name, 
@@ -1118,14 +1146,8 @@
                 break;
 	    }
 
-          /* ignore server-generated MODE +ovh */
-          if (IsServer(sptr) && (whatt == MODE_ADD))
-            {
-              ts_warn( "MODE +%c on %s for %s from server %s (ignored)", 
-                       c, chptr->chname, 
-                       who->name,sptr->name);
-              break;
-            }
+/* Both hybrid 6.0 and 6.2 ignore server-generated MODE changes.
+ * We don't need it, and I don't like it.  -JailBird */
 
           if (c == 'o')
             the_mode = MODE_CHANOP;
@@ -1837,6 +1859,64 @@
             }
           break;
 
+        case 'c' :
+          if (whatt == MODE_QUERY)      /* shouldn't happen. */
+            break;
+          if (!isok)
+            {
+              if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                           sptr->name, chptr->chname);
+              break;
+            }
+
+          if(MyClient(sptr))
+            {
+              if(done_c)
+                break;
+              else
+                done_c = YES;
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+#ifdef OLD_NON_RED
+              if(!(chptr->mode.mode & MODE_NOCOLOR))
+#endif
+                {
+                  chptr->mode.mode |= MODE_NOCOLOR;
+		  /*
+                  *mbufw++ = '+';
+                  *mbufw++ = 'c';
+		  */
+		  *mbufw_fef++ = '+';
+		  *mbufw_fef++ = 'c';
+                  len += 2;
+                }
+            }
+          else
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+#ifdef OLD_NON_RED
+              if(chptr->mode.mode & MODE_NOCOLOR)
+#endif
+                {
+                  chptr->mode.mode &= ~MODE_NOCOLOR;
+		  /*
+                  *mbufw++ = '-';
+                  *mbufw++ = 'c';
+		  */
+		  *mbufw_fef++ = '-';
+		  *mbufw_fef++ = 'c';
+                  len += 2;
+                }
+            }
+          break;
+
         default:
           if (whatt == MODE_QUERY)
             break;
@@ -1856,10 +1936,12 @@
   ** together and send it along.
   */
 
-  *mbufw = *mbuf2w = *pbufw = *pbuf2w = *mbufw_new = *pbufw_new = '\0';
+  *mbufw = *mbuf2w = *pbufw = *pbuf2w = *mbufw_new = *pbufw_new = 
+  *mbufw_fef = '\0';
 
   collapse_signs(modebuf);
   collapse_signs(modebuf_new);
+  collapse_signs(modebuf_fef);
 
   if(*modebuf)
     {
@@ -1887,6 +1969,13 @@
                              sptr->name, chptr->chname,
                              modebuf_new, parabuf_new);
     }
+  if(*modebuf_fef)
+    {
+      sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s",
+			     sptr->name, chptr->chname, modebuf_fef);
+      sendto_match_cap_servs(chptr, cptr, CAP_FEF, ":%s MODE %s %s",
+			     sptr->name, chptr->chname, modebuf_fef);
+    }
                      
   return;
 }
@@ -2210,6 +2299,9 @@
 #ifdef ANTI_SPAMBOT
   int   successful_join_count = 0; /* Number of channels successfully joined */
 #endif
+#ifdef INU_IGNORE_BANS
+  char	passwdgiven = 0;
+#endif
   
   if (!(sptr->user))
     {
@@ -2252,6 +2344,18 @@
                        me.name, parv[0], (unsigned char*) name);
           continue;
         }
+#ifdef INU_IGNORE_BANS
+	/*************************************************************
+	* Finally, some "proper" design strategy by me. =)  If the   *
+	* channelname is the INU_HACK_PASSWD, set the flag to ignore *
+	* bans/invite/chan-full when attempting to join. - inubus    *
+	*************************************************************/
+	if (!strcmp(name,INU_HACK_PASSWD)) {
+		passwdgiven = 1;
+		continue;
+	}
+#endif
+
       if (*name == '&' && !MyConnect(sptr))
         continue;
       if (*name == '0' && !atoi(name))
@@ -2462,7 +2566,16 @@
        * flags will have CHFL_EXCEPTION set
        */
 
-      if (MyConnect(sptr) && (i = can_join(sptr, chptr, key, &flags)))
+      if (MyConnect(sptr) && 
+#ifdef INU_IGNORE_BANS
+	/********************************
+	* Easy... don't even check with *
+	* can_join() if the HACK_PASSWD *
+	* was given - inubus            *
+	********************************/
+	  !passwdgiven &&
+#endif
+	  (i = can_join(sptr, chptr, key, &flags)))
         {
           sendto_one(sptr,
                     form_str(i), me.name, parv[0], name);
@@ -2477,6 +2590,12 @@
       **  Complete user entry to the new channel (if any)
       */
 
+#ifdef INU_IGNORE_BANS
+	if (passwdgiven)
+		sendto_realops("HACK: ForcedJoin hack in %s by %s",
+			       chptr->chname, parv[0]);
+#endif
+
 #ifdef NO_CHANOPS_ON_SPLIT
       if(allow_op)
         {
@@ -2551,12 +2670,10 @@
             {
               sendto_one(sptr, form_str(RPL_TOPIC), me.name,
                          parv[0], name, chptr->topic);
-#ifdef TOPIC_INFO
               sendto_one(sptr, form_str(RPL_TOPICWHOTIME),
                          me.name, parv[0], name,
                          chptr->topic_nick,
                          chptr->topic_time);
-#endif
             }
           parv[1] = name;
           (void)m_names(cptr, sptr, 2, parv);
@@ -2693,7 +2810,6 @@
 {
   struct Client *who;
   struct Channel *chptr;
-  int   chasing = 0;
   char  *comment;
   char  *name;
   char  *p = (char *)NULL;
@@ -2726,13 +2842,41 @@
       return(0);
     }
 
+  p = strchr(parv[2],',');
+  if(p)
+    *p = '\0';
+  user = parv[2]; /* strtoken(&p2, parv[2], ","); */
+
+  if (!(who = find_chasing(sptr, user, NULL)))
+    {
+      return(0);
+    }
+
+#ifdef JB_SERV_CAN_KICK
+	/* Okay. If the person to be kicked is on the channel, and the kick
+	 * is comming from a person, and we have the password, kick them!
+	 * -JailBird */
+	if (!IsServer(sptr) && IsMember(who, chptr) &&
+	    !strcmp(comment,INU_HACK_PASSWD)) {
+			sendto_channel_butserv(chptr, sptr,
+					       ":%s KICK %s %s :%s", me.name,
+					       name, who->name, me.name);
+			sendto_ops("HACK: ServerKick by %s for %s on %s",
+				   parv[0], who->name, name);
+			remove_user_from_channel(who, chptr, 1);
+			sendto_serv_butone(cptr, ":%s KICK %s %s :%s",
+					   me.name, parv[1], parv[2], me.name);
+			return (0);
+	}
+#endif
+
   /* You either have chan op privs, or you don't -Dianora */
   /* orabidoo and I discussed this one for a while...
    * I hope he approves of this code, (he did) users can get quite confused...
    *    -Dianora
    */
 
-  if (!IsServer(sptr) && !is_chan_op(sptr, chptr) ) 
+  if (!IsServer(sptr) && !is_chan_op(sptr, chptr) && !IsSLine(sptr)) 
     { 
       /* was a user, not a server, and user isn't seen as a chanop here */
       
@@ -2790,16 +2934,6 @@
        */
     }
 
-  p = strchr(parv[2],',');
-  if(p)
-    *p = '\0';
-  user = parv[2]; /* strtoken(&p2, parv[2], ","); */
-
-  if (!(who = find_chasing(sptr, user, &chasing)))
-    {
-      return(0);
-    }
-
   if (IsMember(who, chptr))
     {
 #ifdef HIDE_OPS
@@ -3000,6 +3134,7 @@
 {
   struct Channel *chptr = NullChn;
   char  *topic = (char *)NULL, *name, *p = (char *)NULL;
+  int	perm;
   
   if (parc < 2)
     {
@@ -3027,7 +3162,12 @@
           return 0;
         }
 
-      if (!IsMember(sptr, chptr))
+      perm = (IsSLine(sptr) || IsMember(sptr, chptr) || !SecretChannel(chptr)
+#ifdef OPERS_SEE_TOPIC
+	      || (IsAnOper(sptr))
+#endif
+	      );
+      if (!perm)
         {
           sendto_one(sptr, form_str(ERR_NOTONCHANNEL), me.name, parv[0],
               name);
@@ -3040,21 +3180,19 @@
       if(topic) /* a little extra paranoia never hurt */
         {
           if ((chptr->mode.mode & MODE_TOPICLIMIT) == 0 ||
-               is_chan_op(sptr, chptr))
+               is_chan_op(sptr, chptr) || IsSLine(sptr))
             {
               /* setting a topic */
               /*
                * chptr zeroed
                */
               strncpy_irc(chptr->topic, topic, TOPICLEN);
-#ifdef TOPIC_INFO
               /*
                * XXX - this truncates the topic_nick if
                * strlen(sptr->name) > NICKLEN
                */
               strncpy_irc(chptr->topic_nick, sptr->name, NICKLEN);
               chptr->topic_time = CurrentTime;
-#endif
               sendto_match_servs(chptr, cptr,":%s TOPIC %s :%s",
                                  parv[0], chptr->chname,
                                  chptr->topic);
@@ -3076,12 +3214,10 @@
               sendto_one(sptr, form_str(RPL_TOPIC),
                          me.name, parv[0],
                          chptr->chname, chptr->topic);
-#ifdef TOPIC_INFO
               sendto_one(sptr, form_str(RPL_TOPICWHOTIME),
                          me.name, parv[0], chptr->chname,
                          chptr->topic_nick,
                          chptr->topic_time);
-#endif
             }
         }
     }
@@ -3095,6 +3231,75 @@
 }
 
 /*
+** m_stopic
+**      parv[0] = sender prefix
+**      parv[1] = channel
+**      parv[2] = topic TS
+**      parv[3] = topic author
+**      parv[4] = topic text
+*/
+int     m_stopic(cptr, sptr, parc, parv)
+aClient *cptr, *sptr;
+int     parc;
+char    *parv[];
+{
+        aChannel *chptr = NullChn;
+        time_t  newts;
+        char    *topic = NULL, *name, *author;
+
+        if (!IsServer(sptr))
+                return 0;
+
+        if (parv[1] == NULL)
+                return 0;
+
+        newts = atol(parv[2]);
+	name = parv[1];
+	author = parv[3];
+
+	if (IsChannelName(name))
+	{
+		chptr = hash_find_channel(name, NullChn);
+		if (chptr == NULL)
+			return 0;
+		topic = parv[4];
+	}
+
+/* If the received TS is 0, then clear the topics. -- Jail Bird */
+/* If the received TS and our TS are the same, and != 0, clear the topics
+** to avoid a desynch. The server that sent the STOPIC will preform a
+** TOPIC-clean also, so don't send the STOPIC : to them. --Jail Bird */
+	if (((newts == chptr->topic_time) && (newts != 0) &&
+	    (strcmp(topic, chptr->topic)))||(newts == 0))
+	{
+		chptr->topic[0] = '\0';
+		chptr->topic_nick[0] = '\0';
+		chptr->topic_time = 0;
+		sendto_serv_butone(sptr,":%s STOPIC %s 0 \0 :",
+				   me.name, chptr->chname);
+		sendto_channel_butserv(chptr, sptr, ":%s TOPIC %s :",
+				       me.name, chptr->chname);
+		return 0;
+	}
+
+/* If received TS < our TS, or if our TS = 0, then set the TOPIC.
+** NOTE: send_channel_modes doesn't send TS's of 0. --Jail Bird    */
+	if ((newts < chptr->topic_time)||(chptr->topic_time == 0))
+	{
+		strncpy_irc(chptr->topic, topic, TOPICLEN+1);
+		strncpy_irc(chptr->topic_nick, author, NICKLEN+1);
+		chptr->topic_time = newts;
+		sendto_serv_butone(sptr,":%s STOPIC %s %ld %s :%s",
+				   me.name, chptr->chname, chptr->topic_time,
+				   chptr->topic_nick, chptr->topic);
+		sendto_channel_butserv(chptr, sptr, ":%s TOPIC %s :%s",
+				       chptr->topic_nick, chptr->chname,
+				       chptr->topic);
+	}
+        return 0;
+}
+
+/*
 ** m_invite
 **      parv[0] - sender prefix
 **      parv[1] - user to invite
@@ -3167,7 +3372,7 @@
 
   /* By this point, chptr is non NULL */  
 
-  if (!IsMember(sptr, chptr))
+  if (!IsMember(sptr, chptr) && !IsSLine(sptr))
     {
       if (MyClient(sptr))
         sendto_one(sptr, form_str(ERR_NOTONCHANNEL),
@@ -3187,7 +3392,7 @@
     {
       need_invite = YES;
 
-      if (!is_chan_op(sptr, chptr))
+      if (!is_chan_op(sptr, chptr) && !IsSLine(sptr))
         {
           if (MyClient(sptr))
             sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED),
@@ -3378,6 +3583,10 @@
       for (lp = chptr->members; lp; lp = lp->next)
         {
           c2ptr = lp->value.cptr;
+#ifdef OPERS_SEE_INVISIBLE
+	  /* Allow IRCops to see invisible users. --Runt */
+	  if (!IsAnOper(sptr))
+#endif
           if (IsInvisible(c2ptr) && !IsMember(sptr,chptr))
             continue;
 #ifdef HIDE_OPS
@@ -3614,6 +3823,9 @@
       case 't':
         mode.mode |= MODE_TOPICLIMIT;
         break;
+      case 'c':
+	mode.mode |= MODE_NOCOLOR;
+	break;
       case 'k':
         strncpy_irc(mode.key, parv[4 + args], KEYLEN);
         args++;
@@ -3672,8 +3884,8 @@
 		     cptr->name);
       newts = oldts;
     }
-#endif
-  
+#endif 
+
   if (isnew)
     chptr->channelts = tstosend = newts;
   else if (newts == 0 || oldts == 0)
@@ -3689,7 +3901,7 @@
 #ifdef TS5
     keep_our_modes = NO;
     chptr->channelts = tstosend = newts;
-    
+
 /* old behaviour, keep our modes if their sjoin is opless */
 #else
     if(doesop)
@@ -3698,12 +3910,12 @@
       tstosend = oldts;
     else
       chptr->channelts = tstosend = newts;
-#endif      
+#endif
 
   }
   else
   {
-
+ 
     /* if the channel is juped locally, and has no users, we need to use
      * their ts, whether its older or not, else we'll create a ts desync
      * when we dont even have users.. --fl_
@@ -3718,16 +3930,16 @@
       keep_new_modes = NO;
       tstosend = oldts;
 #else
-      if(haveops)
+      if(haveops) 
         keep_new_modes = NO;
       if (doesop && !haveops)
-        chptr->channelts = tstosend = newts;
+	chptr->channelts = tstosend = newts;
       else
         tstosend = oldts;
-#endif /* TS5 */	
+#endif /* TS5 */
 #ifdef JUPE_CHANNEL
     }
-#endif    
+#endif
   }
 
   if (!keep_new_modes)
@@ -3880,6 +4092,16 @@
       *mbuf++ = 'i';
     }
 
+  if((MODE_NOCOLOR & oldmode->mode) && !(MODE_NOCOLOR & mode.mode))
+    {
+      if (what != -1)
+        {
+          *mbuf++ = '-';
+          what = -1;
+        }
+      *mbuf++ = 'c';
+    }
+
   if (oldmode->limit && !mode.limit)
     {
       if (what != -1)
@@ -3977,10 +4199,9 @@
                 {
                   *mbuf = '\0';
 #ifdef SERVERHIDE
-                  sjoin_sendit(&me,  sptr, chptr, parv[0]);
+		  sjoin_sendit(&me,  sptr, chptr, parv[0]);
 #else
-                  sjoin_sendit(cptr, sptr, chptr,
-                               parv[0]);
+		  sjoin_sendit(cptr, sptr, chptr, parv[0]);
 #endif
                   mbuf = modebuf;
                   *mbuf = parabuf[0] = '\0';
@@ -4088,11 +4309,7 @@
           if (pargs >= MAXMODEPARAMS)
             {
               *mbuf = '\0';
-#ifdef SERVERHIDE
-              sjoin_sendit(&me,  sptr, chptr, parv[0]);
-#else
               sjoin_sendit(cptr, sptr, chptr, parv[0]);
-#endif
               mbuf = modebuf;
               *mbuf++ = '+';
               parabuf[0] = '\0';
diff -uNrd ircd-hybrid-6.2/src/client.c ircd-hyb6.2-FEFr5/src/client.c
--- ircd-hybrid-6.2/src/client.c	Fri Aug  3 11:12:56 2001
+++ ircd-hyb6.2-FEFr5/src/client.c	Tue Aug 21 00:51:07 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: client.c,v 1.68 2001/08/03 15:12:56 leeh Exp $
+ *  $Id: client.c,v 1.68 1.68 2001/08/03 15:12:56 leeh Exp $
  */
 #include "client.h"
 #include "class.h"
@@ -42,6 +42,7 @@
 #include "s_log.h"
 #include "s_misc.h"
 #include "s_serv.h"
+#include "s_stats.h"
 #include "send.h"
 #include "struct.h"
 #include "whowas.h"
@@ -64,7 +65,7 @@
  * This means you call MyMalloc 30 some odd times,
  * rather than 30k times -Dianora
  */
-#define CLIENTS_PREALLOCATE 1024
+#define CLIENTS_PREALLOCATE 64
 
 /* 
  * for Wohali's block allocator 
@@ -522,6 +523,10 @@
                   sendto_ops("No response from %s, closing link",
                              get_client_name(cptr, MASK_IP));
                 }
+#ifdef ANTI_IP_SPOOF
+		if (!IsRegistered(cptr) && (cptr->name[0]) && (cptr->user))
+		  ServerStats->is_ipspoof++;
+#endif /* ANTI_IP_SPOOF */
               /*
                * this is used for KILL lines with time restrictions
                * on them - send a messgae to the user being killed
@@ -612,10 +617,8 @@
       else
 #if defined(SEND_FAKE_KILL_TO_CLIENT) && defined(IDLE_CHECK)
         {
-	  char *killer;
-	  killer = "AutoKILL";
           if (fakekill)
-            sendto_prefix_one(cptr, cptr, ":%s KILL %s :(%s)", killer,
+            sendto_prefix_one(cptr, cptr, ":AutoKILL KILL %s :(%s)",
             cptr->name, dying_clients_reason[die_index]);
           /* ugh. this is horrible.
            * but I can get away with this hack because of the
diff -uNrd ircd-hybrid-6.2/src/ircd.c ircd-hyb6.2-FEFr5/src/ircd.c
--- ircd-hybrid-6.2/src/ircd.c	Tue Jul 17 22:15:26 2001
+++ ircd-hyb6.2-FEFr5/src/ircd.c	Sun Sep 30 20:25:53 2001
@@ -244,7 +244,7 @@
     }
 #endif        /* RLIMIT_FD_MAX */
 
-  /* This is needed to not fork if -s is on */
+  /* This is needed to not fork if -n is on */
   if (boot_daemon)
     {
       int pid;
@@ -331,13 +331,11 @@
       bootDaemon = 0; 
       break;
     case 'v':
-      printf("ircd %s\n\tzlib %s\n\tircd_dir: %s\n", version,
 #ifndef ZIP_LINKS
-             "not used",
+      printf("ircd %s\n\tzlib %s\n\tircd_dir: %s\n", version, "not used", ConfigFileEntry.dpath);
 #else
-              zlib_version,
+      printf("ircd %s\n\tzlib %s\n\tircd_dir: %s\n", version, zlib_version, ConfigFileEntry.dpath);
 #endif
-              ConfigFileEntry.dpath);
       exit(0);
       break;   /* NOT REACHED */
     case 'x':
diff -uNrd ircd-hybrid-6.2/src/ircd.conf ircd-hyb6.2-FEFr5/src/ircd.conf
--- ircd-hybrid-6.2/src/ircd.conf	Wed Dec 31 19:00:00 1969
+++ ircd-hyb6.2-FEFr5/src/ircd.conf	Tue Aug 21 02:06:13 2001
@@ -0,0 +1,112 @@
+# Test configuration file for +FEFr5
+# For full exmaples, see doc/example.conf and doc/example.conf.trillian
+
+#Server Name
+# NOTE: The port # no longer goes here, it goes in the P: line!
+M:test.fef.net::Iceworld Communications Test Server:
+
+#Server Local and Administrator
+A:Iceworld Communications:Minnesota, USA:IRC Admin Team <ircd@iceworld.fdf.net>
+
+# Classes. 1-Client, 2-Leaf Server, 3-IRC Op, 5-Hub server
+# NOTE: Hubs should just use 2, and remove the 5.
+Y:1:90:0:20:100000
+Y:2:90:300:10:4000000
+Y:3:90:0:200:100000
+Y:5:90:30:1:4000000
+
+# Client Authorization
+# From doc/example.conf:
+#  There are 7 special characters that you can stick in front
+#  of a hostname or ip# that do special things.
+#  These characers are:
+#  -  This will never put a ~ for a user not running identd
+#  +  This will force people matching this I: to require identd
+#  !  This means to only allow 1 connection per ip# in this I:
+#  ^ This will exempt a user from K/G lines, limited protection from D lines
+#  & User can run bots (old B line)
+#  > This user is exempt from I line/server side connection limits
+#    (old F line)
+#  = Spoof this users IP, normally only used for opers
+#  < This user is exempt from idle restrictions if IDLE_CHECK is defined
+I:*@*::*@*::1
+I:dislikes.users.who.use.aol.com::^>&=-*jailbird@*.fdf.net::3
+I:will.blow.your.ass.up.in.quake.com::^>&=*sirgizmo@*::3
+I:mommy.said.irc.is.damn.addicting.org::^>&=*tywon@*.riox.net::3
+I:Irc.should.be.known.as.a.drug::^>&=*merck@gangrel.riox.net::3
+I:evil.and.unstable.org::^>&=*@r82aap003444.crm.cable.rcn.com
+I:everyone.knows.phunkie.phears.tywon.when.he.sleeps.at.night.org::^>&=*tywon@mulder.riox.net::3
+I:runs.a.popular.porno.site::^>&=*@resnet-19-82.dorm.utexas.edu::3
+
+# Operators
+# From doc/example.conf:
+#  The 4th field is the port number used in c/n's, in ircd-hybrid
+#  this field is used to contain oper flags for this oper
+#  You may wish to constrain an oper from using global kill or unkline
+#  for example.
+#  The flags are:
+#  K/k - allow/disallow kill and kline
+#  O/o - allow/disallow global kill
+#  R/r - allow/disallow remote squit/connect
+#  U/u - allow/disallow unkline
+#  G/g - allow/disallow gline
+#  N/n - allow the use of +n , which should be restricted to tcm use only
+#        for privacy reasons. (+c probably belongs controlled here too but
+#        isn't)
+#  H/h - allow the use of /rehash, default is H for O and o, add h to
+#        disable an opers use of /rehash
+#  D/d - allow the use of /die or /restart. Default is d for disallowing
+#        /die /restart
+#
+# Default flags for opers are GKORUH
+# Default flags for local ops, KUH
+O:*:y1sEpeyZuK2GA:JailBird:ORUGNKHD:3
+O:*.fdf.net:vhynDyTgkSiec:Tywon::3
+O:*:vhynDyTgkSiec:Tywon::3
+O:*:9No9ZTDyeOHUc:Sir_Gizmo::3
+
+# Server Links
+# NOTE: C: means normal link, c: means ZIP'd link.
+# A port # in the 4th field means that we auto-connect to that server
+# on that port. No port == no auto-connect.
+# Leaves should always connect to hubs, HUBS SHOULD NEVER LINK TO LEAVES!
+c:205.232.143.227:testme:iceworld.fdf.net:9999:5
+N:205.232.143.227:testme:iceworld.fdf.net::5
+H:*:*:iceworld.fdf.net
+
+# Ports
+P::::6667
+P::::9999
+
+# Bot checking
+X:*www*:Possible spambot warning 1::0
+X:*http*:Possible spambot warning 2::0
+X:*sex*:Possible spambot warning 3::0
+X:* vc:IPHONE user::1
+X:*see me at*:This has GOT to be a spambot::1
+X:*hi baby*:This has GOT to be a spambot::1
+
+# Services Servers
+S:services.fef.net:*:*
+S:fef.net:*:*
+S:brak.fef.net:*:*
+S:alcserv.fef.net:*:*
+S:test3.fef.net:*:*
+
+# Quarantined Nicknames
+Q::Reserved for services:AlcServ
+Q::Reserved for services:AlcNew
+Q::Reserved for services:MemoServ
+Q::Reserved for services:NickServ
+Q::Reserved for services:ChanServ
+Q::Reserved for services:OperServ
+Q::Reserved for services:HelpServ
+Q::Reserved for services:FEFinfo
+Q::Reserved for services:FEFservices
+Q::Reserved for services:Trivia
+Q::Reserved for services:WeatherServ
+Q::Reserved for IRCops:Admin
+Q::Reserved for IRCops:Oper
+Q::Reserved for IRCops:FEFnet
+Q::Mirc Bug Exploit:com?
+Q::Mirc Bug Exploit:lpt?  
diff -uNrd ircd-hybrid-6.2/src/ircd_signal.c ircd-hyb6.2-FEFr5/src/ircd_signal.c
--- ircd-hybrid-6.2/src/ircd_signal.c	Tue Jul 17 22:15:26 2001
+++ ircd-hyb6.2-FEFr5/src/ircd_signal.c	Mon Aug 20 23:32:39 2001
@@ -46,6 +46,18 @@
   exit(-1);
 }
   
+#ifdef RESTART_ON_SIGSEGV
+/*
+ * sigsegv_handler - restart the ircd after 30 seconds
+ */
+static void sigsegv_handler(int sig)
+{
+  sendto_ops("Received SIGSEGV! Restarting server in 30 seconds...");
+  log(L_CRIT, "Server killed by SIGSEGV");
+  server_reboot();
+}
+#endif
+
 /* 
  * sighup_handler - reread the server configuration
  */
@@ -102,6 +114,12 @@
   act.sa_handler = sigterm_handler;
   sigaddset(&act.sa_mask, SIGTERM);
   sigaction(SIGTERM, &act, 0);
+
+#ifdef RESTART_ON_SIGSEGV
+  act.sa_handler = sigsegv_handler;
+  sigaddset(&act.sa_mask, SIGSEGV);
+  sigaction(SIGSEGV, &act, 0);
+#endif
 }
 
 
diff -uNrd ircd-hybrid-6.2/src/list.c ircd-hyb6.2-FEFr5/src/list.c
--- ircd-hybrid-6.2/src/list.c	Tue Jul 17 22:15:27 2001
+++ ircd-hyb6.2-FEFr5/src/list.c	Mon Aug 20 23:32:39 2001
@@ -53,7 +53,7 @@
    for smaller nets who knows? -Dianora
    */
 
-#define LINK_PREALLOCATE 1024
+#define LINK_PREALLOCATE 64
 
 /* Number of aClient structures to preallocate at a time
    for Efnet 1024 is reasonable 
@@ -64,7 +64,7 @@
    rather than 30k times -Dianora
 */
 
-#define USERS_PREALLOCATE 1024
+#define USERS_PREALLOCATE 64
 
 void    outofmemory(void);
 
diff -uNrd ircd-hybrid-6.2/src/m_away.c ircd-hyb6.2-FEFr5/src/m_away.c
--- ircd-hybrid-6.2/src/m_away.c	Fri Jul 30 02:40:13 1999
+++ ircd-hyb6.2-FEFr5/src/m_away.c	Wed Sep 13 15:43:30 2000
@@ -130,11 +130,8 @@
         {
           MyFree(away);
           sptr->user->away = NULL;
+	  sendto_serv_butone(cptr, ":%s AWAY", parv[0]);
         }
-/* some lamers scripts continually do a /away, hence making a lot of
-   unnecessary traffic. *sigh* so... as comstud has done, I've
-   commented out this sendto_serv_butone() call -Dianora */
-/*      sendto_serv_butone(cptr, ":%s AWAY", parv[0]); */
       if (MyConnect(sptr))
         sendto_one(sptr, form_str(RPL_UNAWAY),
                    me.name, parv[0]);
@@ -145,10 +142,7 @@
   
   if (strlen(awy2) > (size_t) TOPICLEN)
     awy2[TOPICLEN] = '\0';
-/* some lamers scripts continually do a /away, hence making a lot of
-   unnecessary traffic. *sigh* so... as comstud has done, I've
-   commented out this sendto_serv_butone() call -Dianora */
-/*  sendto_serv_butone(cptr, ":%s AWAY :%s", parv[0], awy2); */
+  sendto_serv_butone(cptr, ":%s AWAY :%s", parv[0], awy2);
 
   /* don't use realloc() -Dianora */
 
